/*
  The contents of this file are subject to the Initial Developer's Public
  License Version 1.0 (the "License"); you may not use this file except in
  compliance with the License. You may obtain a copy of the License here:
  http://www.flamerobin.org/license.html.

  Software distributed under the License is distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
  License for the specific language governing rights and limitations under
  the License.

  The Original Code is FlameRobin (TM).

  The Initial Developer of the Original Code is Nando Dessena.

  Portions created by the original developer
  are Copyright (C) 2004 Nando Dessena.

  All Rights Reserved.

  $Id: exception.h,v 1.5 2005/08/31 21:17:52 nandod Exp $

  Contributor(s): Nando Dessena
*/

//-----------------------------------------------------------------------------
#ifndef FR_EXCEPTION_H
#define FR_EXCEPTION_H

#include "metadataitem.h"
//-----------------------------------------------------------------------------
class Exception: public MetadataItem
{
private:
    bool propertiesLoadedM;
    std::string messageM;
    int numberM;
public:
    Exception();
    virtual std::string getCreateSqlTemplate() const;
    virtual const std::string getTypeName() const;

    std::string getMessage();
    int getNumber();
    std::string getAlterSql();
    void loadProperties(bool force = false);
    virtual void acceptVisitor(MetadataItemVisitor* visitor);
};
//-----------------------------------------------------------------------------
#endif // FR_EXCEPTION_H
