/*
  The contents of this file are subject to the Initial Developer's Public
  License Version 1.0 (the "License"); you may not use this file except in
  compliance with the License. You may obtain a copy of the License here:
  http://www.flamerobin.org/license.html.

  Software distributed under the License is distributed on an "AS IS"
  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
  License for the specific language governing rights and limitations under
  the License.

  The Original Code is FlameRobin (TM).

  The Initial Developer of the Original Code is Milan Babuskov.

  Portions created by the original developer
  are Copyright (C) 2004 Milan Babuskov.

  All Rights Reserved.

  $Id: function.h,v 1.7 2005/08/31 21:17:52 nandod Exp $

  Contributor(s): Nando Dessena
*/

//-----------------------------------------------------------------------------
#ifndef FR_FUNCTION_H
#define FR_FUNCTION_H

#include "metadataitem.h"
//-----------------------------------------------------------------------------
class Function: public MetadataItem
{
private:
	std::string libraryNameM, entryPointM, definitionM;
	bool infoLoadedM;
	void loadInfo(bool force = false);
public:
	Function();
	virtual const std::string getTypeName() const;
    virtual std::string getCreateSqlTemplate() const;
    virtual std::string getDropSqlStatement() const;
	std::string getDefinition();
	std::string getHtmlHeader();
    virtual void acceptVisitor(MetadataItemVisitor* visitor);
};
//-----------------------------------------------------------------------------
#endif
